"use strict";
class DelayedFetch {
    constructor(delayedFunction) {
        this.request = request;
        this.fetchFunction = fetch;
        this.innerPromise = null;
    }
    withHeader(key, value) {
        this.request.headers.set(key, value);
        return this;
    }
    then(onfulfilled, onrejected) {
        return this.doInner().then(onfulfilled, onrejected);
    }
    catch(onrejected) {
        return this.doInner().catch(onrejected);
    }
    doInner() {
        if (!this.innerPromise) {
            this.innerPromise = this.fetchFunction(this.request);
        }
        return this.innerPromise;
    }
}
//# sourceMappingURL=delayed-fetch.js.map