"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const base_1 = require("./base");
/**
 * The Representation class is basically a 'body' of a request
 * or response.
 *
 * This class is special because it doesn't exactly represent a specific
 * content-type, but rather the result of a HEAD request.
 *
 * This result may have links set in its HTTP headers, and this class
 * is the primary means to access them.
 */
class Head extends base_1.default {
    /**
     * parse is called to convert a HTTP response body string into the most
     * suitable internal body type.
     *
     * For JSON responses, usually this means calling JSON.parse() and returning
     * the result.
     */
    parse(body) {
        return null;
    }
}
exports.default = Head;
//# sourceMappingURL=head.js.map