import { OAuth2, OAuth2Options } from 'fetch-mw-oauth2';
import './fetch-polyfill';
/**
 * This options format exists for backwards compatibility.
 *
 * The currect new format is 'OAuth2Options'.
 *
 * See the fetch-mw-oauth2 project for details:
 * https://github.com/evert/fetch-mw-oauth2
 */
export declare type BCOAuth2Options = {
    client: {
        clientId: string;
        clientSecret: string;
        accessTokenUri: string;
        scopes: string[];
    };
    owner?: {
        userName: string;
        password: string;
    };
};
export declare type OAuth2Init = (BCOAuth2Options | OAuth2Options);
export declare class OAuth2Helper {
    oauth2: OAuth2;
    constructor(options: OAuth2Init);
    /**
     * Does a HTTP request with OAuth2 enabled.
     *
     * This function will automatically grab an access token if it didn't have
     * one, and attempt to refresh the token if it was expired.
     */
    fetch(request: Request): Promise<Response>;
}
