import { AuthOptions, KettingInit } from '../types';
import './fetch-polyfill';
declare type DomainOptions = {
    fetchInit: RequestInit;
    auth: AuthOptions;
    authBucket: string;
};
declare type beforeRequestCallback = (request: Request) => void;
/**
 * This class is primarily responsible for calling fetch().
 *
 * It's main purpose besides that is to add authentication headers, and
 * any defaults that might have been set.
 */
export default class FetchHelper {
    private options;
    private oAuth2Buckets;
    private innerFetch;
    private onBeforeRequest;
    constructor(options: KettingInit, onBeforeRequest?: beforeRequestCallback | null);
    fetch(requestInfo: RequestInfo, requestInit: RequestInit): Promise<Response>;
    getDomainOptions(uri: string): DomainOptions;
    /**
     * This method executes the actual fetch() function, but not before adding
     * authentication headers.
     */
    private fetchAuth;
    /**
     * This function is the last mile before the actual fetch request is ran
     */
    private doFetch;
}
declare type HeaderSet = any;
/**
 * Merges sets of HTTP headers.
 *
 * Each item in the array is a key->value object, a Fetch Headers object
 * or falsey.
 *
 * Any headers that appear more than once get replaced. The last occurence
 * wins.
 */
export declare function mergeHeaders(headerSets: HeaderSet[]): Headers;
export {};
