"use strict";
class representationFetcher {
    constructor(fetchFunction) {
        this.inflightRefreshes = new Map();
        this.fetchFunction = fetchFunction;
    }
    doRefresh(uri, headers) {
        if (this.inflightRefreshes.has(uri)) {
            return this.inflightRefreshes.get(uri);
        }
        let response;
        let body;
        const refreshPromise = this.fetchFunction(uri, {
            method: 'GET',
            headers
        }).then(result1 => {
            response = result1;
            return result1.text();
        }).then((result2) => {
            body = result2;
            return [response, body];
        });
        this.inflightRefreshes.set(uri, refreshPromise);
        return refreshPromise;
    }
}
//# sourceMappingURL=representation-fetcher.js.map