type RefreshPair = [Response, string];
type headers = { [key: string]: string };

class representationFetcher {

  private inflightRefreshes: Map<string, Promise<RefreshPair>>;
  private fetchFunction: typeof fetch;

  constructor(fetchFunction: typeof fetch) {
    this.inflightRefreshes = new Map();
    this.fetchFunction = fetchFunction;
  }

  doRefresh(uri: string, headers: Headers): Promise<RefreshPair> {

    if (this.inflightRefreshes.has(uri)) {
      return this.inflightRefreshes.get(uri)!;
    }

    let response: Response;
    let body: string;

    const refreshPromise = this.fetchFunction(uri, {
      method: 'GET',
      headers
    }).then( result1 => {
      response = result1;
      return result1.text();
    }).then( (result2): RefreshPair => {
      body = result2;
      return [response, body];
    });

    this.inflightRefreshes.set(uri, refreshPromise);

    return refreshPromise;

  }

}
